<template>
	<mind-layout>
		<mind-form v-model="datosCliente" @submit="onSubmit">
			<template v-slot="{form}">
					<el-form-item label="Nombre">
								<el-input v-model="form.nombre" />
					</el-form-item>
					<el-row  >
							<el-col  :lg="12">
								<el-form-item label="Direccion">
										<select-lugar calles placeholder="Calle" v-model="form.calle" />
								</el-form-item>
							</el-col>
							<el-col  :lg="12">
								<el-form-item label="Numero">
									<el-col  :lg="8">
										<el-input placeholder="Numero" type="text" v-model.number="form.numero" />
									</el-col>
									<el-col  :lg="8">
										<el-input clearable placeholder="Piso" v-model.number="form.piso" />
									</el-col>
									<el-col  :lg="8">
										<el-input placeholder="Depto" v-model="form.depto" />
									</el-col>
								</el-form-item>
							</el-col>
					</el-row>
					<el-row >
						<el-col  :lg="12">
							<el-form-item label="Entre" >
									<select-lugar calles placeholder="Calle 1" v-model="form.calle1" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item label="y" >
									<select-lugar calles placeholder="Calle 2" v-model="form.calle2" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row >
						<el-col  :lg="12">
							<el-form-item label="Localidad">
								<el-input v-model="form.localidad" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item label="Partido">
								<el-input v-model="form.partido" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item label="Provincia">
								<el-input v-model="form.provincia" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row >
						<el-col  :lg="12">
							<el-form-item label="Teléfono Fijo">
								<el-input v-model="form.telefono" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item label="Movil">
								<el-input v-model="form.movil" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row >
						<el-col :lg="12" >
							<el-form-item label="Correo">
								<el-input v-model="form.correo" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row >
						<el-col :lg="24" >
							<el-form-item  label="Notas">
								<el-input type="textarea" rows="5" v-model="form.obs" />
							</el-form-item>
						</el-col>
					</el-row>
			</template>
		</mind-form>
	</mind-layout>
</template>
<script>
import store from '@/store/clientes'
import {Rest} from '@/../vendor/mind-core-web'
import selectLugar from '@/components/select-lugar'

export default {
	components:{
		selectLugar
	},
	async created(){
		this.api = new Rest({
			uri: `/api/viajes/agencias/${store.idAgencia}/clientes`, 
			state: store.data,
			key: 'id'
		})

		let id = this.$route.params.id
		if(id == 'new') {
			this.isNew = true
			this.datosCliente = {	}
		} else {
			this.datosCliente = await this.api.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})
		}
	},
	methods: {
		async onSubmit(data) {
			let result, msg ;
			if(this.isNew) {
				await this.api.Post(data)
				.then(()=>{
					result = 'success'
					msg = 'Cliente creado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			} else {
				await this.api.Patch(data)
				.then(()=>{
					result = 'success'
					msg = 'Cliente actualizado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			}
			this.$message({
				type: result,
				showClose: result == 'error',
				message: msg
			});
		},
	},
	data() {
		return {
			isNew: false,
			datosCliente: {},
			api: null,
		}
	}
}
</script>